<template>
    <div class="guest-form">
        <div class="title-wrapper">
            <div class="--margin"></div>
            <div class="titles">
                <h1 class="title">
                    Create Your
                    <strong>Free</strong> Offline Account
                </h1>
                <h2 class="subtitle">
                    Enter your
                    <strong>First Name</strong> (required) and
                    <strong>Last Name</strong> (Optional)
                </h2>
            </div>
            <div class="--margin"></div>
        </div>
        <div class="form-wrapper">
            <div class="--margin"></div>
            <div class="form">
                <form autocomplete="off">
                    <div class="form-control">
                        <label for="firstName">First Name</label>
                        <input
                            v-model="$v.firstName.$model"
                            minlength="2"
                            maxlength="30"
                            required
                            type="text"
                            name="firstName"
                            id="firstName"
                        />
                        <span class="error" v-if="!$v.firstName.minLength && $v.firstName.$dirty">
                            <app-icon icon="exclamation-circle"></app-icon>
                            <span class="message">
                                Error: Minimum Length is
                                <strong>2</strong> Characters
                            </span>
                        </span>
                        <span class="error" v-if="!$v.firstName.maxLength && $v.firstName.$dirty">
                            <app-icon icon="exclamation-circle"></app-icon>
                            <span class="message">
                                Error: Maximium Length is
                                <strong>30</strong> Characters
                            </span>
                        </span>
                        <span class="error" v-if="!$v.firstName.required && $v.firstName.$dirty">
                            <app-icon icon="exclamation-circle"></app-icon>
                            <span class="message">
                                Error: First Name Is
                                <strong>Required</strong>
                            </span>
                        </span>
                    </div>
                    <div class="form-control">
                        <label for="lastName">Last Name</label>
                        <input
                            v-model="$v.lastName.$model"
                            minlength="2"
                            maxlength="30"
                            type="text"
                            name="lastName"
                            id="lastName"
                        />
                        <span class="error" v-if="!$v.lastName.minLength && $v.lastName.$dirty">
                            <app-icon icon="exclamation-circle"></app-icon>
                            <span class="message">
                                Error: Minimum Length is
                                <strong>2</strong> Characters
                            </span>
                        </span>
                        <span class="error" v-if="!$v.lastName.maxLength && $v.lastName.$dirty">
                            <app-icon icon="exclamation-circle"></app-icon>
                            <span class="message">
                                Error: Maximium Length is
                                <strong>30</strong> Characters
                            </span>
                        </span>
                    </div>
                    <div class="form-control">
                        <button @click.prevent="signUp" class="form-submit">Sign Up</button>
                    </div>
                </form>
            </div>
            <div class="--margin"></div>
        </div>
    </div>
</template>

<script lang='ts'>
import Vue from 'vue'
import Component from 'vue-class-component'
import { validationMixin } from 'vuelidate'
import { required, maxLength, minLength } from 'vuelidate/lib/validators'
import { offlineDB } from '@/offline/db'
import { IUserState } from '../../store/types/user'

const validations = {
    firstName: {
        required,
        minLength: minLength(2),
        maxLength: maxLength(30),
    },
    lastName: {
        minLength: minLength(2),
        maxLength: maxLength(30),
    },
}

const customVNode = Vue.extend({
    validations,
    mixins: [validationMixin],
})

@Component
export default class App extends customVNode {
    // Lifecyles

    // Data
    firstName = ''
    lastName: string | undefined = undefined
    validations = {
        firstName: {
            required,
            minLength: minLength(2),
            maxLength: maxLength(30),
        },
        lastName: {
            minLength: minLength(2),
            maxLength: maxLength(30),
        },
    }

    // Methods
    signUp() {
        if (!this.$v.$invalid) {
            // Successs
            // -> Save to DB

            const payload: IUserState = {
                firstName: this.firstName,
                lastName: this.lastName,
            }

            offlineDB.saveUser(payload)

            // -> Go to App
            this.$router.push({ name: 'notebooks' })
        } else {
            // Handle Validation Error
        }
    }
}
</script>